using System.Collections.Generic;
using System.Numerics;
using System;

namespace once__at_the_end_of_time
{
    internal class Program
    {
        static bool funk(int target, List<int> k)
        {
            int a = 0;
            int b = 0;
            int x = 0;
            int y = 0;
            if ((k.Count() - target) % 2 != 0)
            {
                return false;
            }
            for (int i = 0; i < k.Count(); i++)
            {
                if (k[i] > 0)
                {
                    a++;
                }
                else
                {
                    b++;
                }
                if (k[i] >= target)
                {
                    x++;
                }
                else
                {
                    y++;
                }
            }
            if (x < ((k.Count() - target) / 2) || y < ((k.Count() - target) / 2))
            {
                return false;
            }
            if (a < target || b > target)
            {
                return false;
            }
            return true;
        }
        static void Main(string[] args)
        {
            int t;
            int n, target; //lepse zvuci target nego k iskr
            int h = 0; //trenutna
            t = Convert.ToInt32(Console.ReadLine());
            string[] str = Console.ReadLine().Split(' ');
            n = Convert.ToInt32((string)str[0]);
            target = Convert.ToInt32((string)str[1]);
            List<int> a = new List<int>(n);
            List<int> w = new List<int>(); //ako je t==1 w je rezultat
            string[] aaa = Console.ReadLine().Split(' ');
            for (int i = 0; i < n; i++)
            {
                a.Add(Convert.ToInt32((string)aaa[i]));
            }
            if((n - target) % 2 == 0)
            {
                Console.WriteLine("DA");
                if(t == 1)
                {
                    for(int i =  0; i < n; i++)
                    {
                        Console.Write(a.ElementAt(i) + " ");
                    }
                }
            }
            else
            {
                Console.WriteLine("NE");
            }

        }
    }
}